package org.faktorips.tutorial.modell.base;

import org.faktorips.runtime.ClassloaderRuntimeRepository;
import org.faktorips.runtime.IRuntimeRepository;

/**
 * Diese Klasse bietet Zugriff auf das FaktorIPS Runtime Repository.
 * 
 * <p>
 * Das Ablegen der {@code RuntimeRepositoryFactory} im gleichen Eclipse plug-in
 * Projekt wie das TOC-File stellt sicher, dass der Classloader
 * die XML Resourcen findet.
 */
public class BaseModellRuntimeRepositoryFactory {

	/** Pfad zum FaktorIPS repository. */
	static final String REPOSITORY_TOC_XML = "org/faktorips/tutorial/modell/"
			+ "internal/faktorips-repository-toc.xml";

	/**
	 * 
	 * Gibt das FaktorIPS Runtime-Repository zurück, dass die im Tutorial
	 * erstellte Produktkonfiguration enthält.
	 * 
	 * @return The {@code IRuntimeRepository}.
	 */
	public static IRuntimeRepository createRuntimeRepository() {
		IRuntimeRepository repository = ClassloaderRuntimeRepository.create(
				BaseModellRuntimeRepositoryFactory.REPOSITORY_TOC_XML,
				BaseModellRuntimeRepositoryFactory.class.getClassLoader());
		return repository;
	}
}
