/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.modell.base;

import java.util.GregorianCalendar;
import java.util.List;

import org.faktorips.runtime.IConfigurableModelObject;
import org.faktorips.runtime.INotificationSupport;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.values.Money;
import org.faktorips.valueset.OrderedValueSet;
import org.faktorips.runtime.IVisitorSupport;

/**
 * Published Interface von Vertrag.
 * 
 * @generated
 */
public interface IVertrag extends IConfigurableModelObject, IVisitorSupport, INotificationSupport {

    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft zahlweise.
     * 
     * @generated
     */
    public final static String PROPERTY_ZAHLWEISE = "zahlweise";

    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft jahresbasisbeitrag.
     * 
     * @generated
     */
    public final static String PROPERTY_JAHRESBASISBEITRAG = "jahresbasisbeitrag";
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft nettobeitragZw.
     * 
     * @generated
     */
    public final static String PROPERTY_NETTOBEITRAGZW = "nettobeitragZw";
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft bruttobeitragZw.
     * 
     * @generated
     */
    public final static String PROPERTY_BRUTTOBEITRAGZW = "bruttobeitragZw";

    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft wirksamAb.
     * 
     * @generated
     */
    public final static String PROPERTY_WIRKSAMAB = "wirksamAb";

    /**
     * Diese Konstante enthaelt den Name der Beziehung deckungen.
     * 
     * @generated
     */
    public final static String ASSOCIATION_DECKUNGEN = "deckungen";

    /**
     * Gibt die maximal erlaubten Werte fuer die Eigenschaft zahlweise zurueck.
     * 
     * @generated
     */
    public static final OrderedValueSet<Integer> MAX_ALLOWED_VALUES_FOR_ZAHLWEISE = new OrderedValueSet<Integer>(false,
            null, Integer.valueOf(1), Integer.valueOf(2), Integer.valueOf(4), Integer.valueOf(12));

    /**
     * Gibt den Wert des Attributs zahlweise zurueck.
     * <p>
     * Anzahl der Zahlungen pro Jahr.
     * 
     * @generated
     */
    public Integer getZahlweise();

    /**
     * Setzt den Wert des Attributs zahlweise.
     * <p>
     * Anzahl der Zahlungen pro Jahr.
     * 
     * @generated
     */
    public void setZahlweise(Integer newValue);

    /**
     * Gibt den erlaubten Wertebereich fuer das Attribut zahlweise zurueck.
     * 
     * @generated
     */
    public OrderedValueSet<Integer> getAllowedValuesForZahlweise(IValidationContext context);

    /**
     * Gibt den Wert des Attributs jahresbasisbeitrag zurueck.
     * 
     * @generated
     */
    public Money getJahresbasisbeitrag();

    /**
     * Gibt den Wert des Attributs nettobeitragZw zurueck.
     * 
     * @generated
     */
    public Money getNettobeitragZw();

    /**
     * Gibt den Wert des Attributs bruttobeitragZw zurueck.
     * 
     * @generated
     */
    public Money getBruttobeitragZw();

    /**
     * Gibt den Wert des Attributs wirksamAb zurueck.
     * 
     * @generated
     */
    public GregorianCalendar getWirksamAb();

    /**
     * Setzt den Wert des Attributs wirksamAb.
     * 
     * @generated
     */
    public void setWirksamAb(GregorianCalendar newValue);

    /**
     * Gibt die Anzahl der Deckungen zurueck.
     * 
     * @generated
     */
    public int getNumOfDeckungen();

    /**
     * Gibt die referenzierten Deckungen zurueck.
     * 
     * @generated
     */
    public List<IDeckung> getDeckungen();

    /**
     * Gibt <code>true</code> zurueck, falls das uebergebene Objekt in der Beziehung enthalten ist,
     * ansonsten <code>false</code>.
     * 
     * @generated
     */
    public boolean containsDeckung(IDeckung objectToTest);

    /**
     * Gibt Produkt zurueck, welches Vertrag konfiguriert.
     * 
     * @generated
     */
    public IProdukt getProdukt();

    /**
     * Setzt neuen Produkt.
     * 
     * @param produkt Der neue Produkt.
     * @param initPropertiesWithConfiguratedDefaults <code>true</code> falls die Eigenschaften mit
     *            den Defaultwerte aus Produkt belegt werden sollen.
     * 
     * @generated
     */
    public void setProdukt(IProdukt produkt, boolean initPropertiesWithConfiguratedDefaults);

    /**
     * Gibt Generation zurueck, welches Produkt konfiguriert. Generation wird anhand des
     * Wirksamkeitsdatum ermittelt.
     * 
     * @generated
     */
    public IProduktGen getProduktGen();

    /**
     * @generated
     */
    public void berechneBeitrag();

}
