/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.modell.internal.base;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Calendar;
import java.util.Map;

import org.faktorips.runtime.AssociationChangedEvent;
import org.faktorips.runtime.IConfigurableModelObject;
import org.faktorips.runtime.IModelObject;
import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.IObjectReferenceStore;
import org.faktorips.runtime.internal.XmlCallback;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.runtime.IpsPropertyChangeSupport;
import org.faktorips.runtime.MessageList;

import org.faktorips.runtime.internal.AbstractModelObject;
import org.faktorips.tutorial.modell.base.IDeckung;
import org.faktorips.tutorial.modell.base.IDeckungstyp;
import org.faktorips.runtime.IProductComponent;
import org.faktorips.tutorial.modell.base.IDeckungstypGen;
import org.faktorips.runtime.IProductComponentGeneration;
import org.faktorips.values.Money;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import javax.xml.bind.annotation.XmlAttribute;
import org.faktorips.runtime.jaxb.ProductConfigurationXmlAdapter;
import org.faktorips.runtime.internal.ProductConfiguration;
import org.w3c.dom.Element;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import org.faktorips.runtime.IModelObjectVisitor;

/**
 * Implementierung von IDeckung.
 * 
 * @generated
 */
@XmlRootElement(name = "Deckung")
public abstract class Deckung extends AbstractModelObject implements IDeckung {

    /**
     * Hilfsobjekt fuer Changelistener.
     * 
     * @generated
     */
    protected final IpsPropertyChangeSupport propertyChangeSupport = new IpsPropertyChangeSupport(this);
    /**
     * Membervariable fuer jahresbasisbeitrag.
     * 
     * @generated
     */
    @XmlElement(name = "jahresbasisbeitrag", nillable = true)
    private Money jahresbasisbeitrag = Money.NULL;

    /**
     * Haelt eine Referenz auf die aktuell eingestellte Produktkonfiguration.
     * 
     * @generated
     */
    @XmlJavaTypeAdapter(value = ProductConfigurationXmlAdapter.class)
    @XmlAttribute(name = "product-component.id")
    private final ProductConfiguration productConfiguration;

    /**
     * Erzeugt eine neue Instanz von Deckung.
     * 
     * @generated
     */
    public Deckung() {
        super();
        productConfiguration = new ProductConfiguration();
    }

    /**
     * Erzeugt eine neue Instanz von Deckung.
     * 
     * @generated
     */
    public Deckung(IDeckungstyp productCmpt) {
        super();
        productConfiguration = new ProductConfiguration(productCmpt);
    }

    /**
     * Gibt den Wert des Attributs bezeichnung zurueck.
     * <p>
     * Bezeichnung für die Anzeige an der Oberfläche
     * 
     * @generated
     */
    public String getBezeichnung() {
        return getDeckungstypGen().getBezeichnung();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getJahresbasisbeitrag() {
        return jahresbasisbeitrag;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated NOT
     */
    @Override
    public void berechneJahresbasisbeitrag() {
        Money oldValue = jahresbasisbeitrag;
        jahresbasisbeitrag = berechneJahresbasisbeitragInternal();
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_JAHRESBASISBEITRAG, oldValue, jahresbasisbeitrag));

    }

    /**
     * Methode muss in Subklassen implementiert werden und den Jahresbasisbeitrag der Deckung
     * zurueckliefern.
     */
    public abstract Money berechneJahresbasisbeitragInternal();

    /**
     * Initialisiert Attribute mit ihren Vorgabewerten.
     * 
     * @restrainedmodifiable
     */
    @Override
    public void initialize() {

        // begin-user-code
        // end-user-code
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IDeckungstyp getDeckungstyp() {
        return (IDeckungstyp)getProductComponent();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IDeckungstypGen getDeckungstypGen() {
        return (IDeckungstypGen)getProductCmptGeneration();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentGeneration getProductCmptGeneration() {
        return productConfiguration.getProductCmptGeneration(getEffectiveFromAsCalendar());
    }

    /**
     * Setzt die aktuelle ProductComponentGeneration.
     * 
     * @generated
     */
    public void setProductCmptGeneration(IProductComponentGeneration productComponentGeneration) {
        productConfiguration.setProductCmptGeneration(productComponentGeneration);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setDeckungstyp(IDeckungstyp deckungstyp, boolean initPropertiesWithConfiguratedDefaults) {
        setProductComponent(deckungstyp);
        if (initPropertiesWithConfiguratedDefaults) {
            initialize();
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponent getProductComponent() {
        return productConfiguration.getProductComponent();
    }

    /**
     * Setzt die aktuelle ProductComponent.
     * 
     * @generated
     */
    public void setProductComponent(IProductComponent productComponent) {
        productConfiguration.setProductComponent(productComponent);
    }

    /**
     * Diese Methode wird aufgerufen, wenn sich das Wirksamkeitsdatum aendert und somit die Referenz
     * zur aktuellen Anpassungsstufe nicht mehr gilt. Wenn dieser Vertragsteil andere
     * Kindkomponenten enthaelt, entfernt diese Methode ebenfalls die Referenz zur deren
     * Anpassungsstufe.
     * <p>
     * Die Anpassungsstufe wird nur entfernt, wenn ein neues Wirksamkeitsdatum existiert. Wenn
     * {@link #getEffectiveFromAsCalendar()} <code>null</code> zurueck liefert, wird die
     * Anpassungsstuffe nicht entfernt. Z.B wenn dieses Model-Objekt von seinem Elternteil entfernt
     * wurde.
     * <p>
     * Ableitungen koennen das Verhalten durch Ueberschreiben der Methode
     * {@link #resetProductCmptGenerationAfterEffectiveFromHasChanged()} aendern.
     * 
     * @generated
     */
    public void effectiveFromHasChanged() {
        if (getEffectiveFromAsCalendar() != null) {
            resetProductCmptGenerationAfterEffectiveFromHasChanged();
        }
    }

    /**
     * Setzt die ProductComponentGeneration zurueck.
     * <p>
     * Die Methode kann ueberschrieben werden, um das Verhalten bei Aenderung des Wirksamkeitsdatums
     * zu beeinflussen.
     * 
     * @generated
     */
    protected void resetProductCmptGenerationAfterEffectiveFromHasChanged() {
        productConfiguration.resetProductCmptGeneration();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Calendar getEffectiveFromAsCalendar() {
        IModelObject parent = getParentModelObject();
        if (parent instanceof IConfigurableModelObject) {
            return ((IConfigurableModelObject)parent).getEffectiveFromAsCalendar();
        }
        return null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void notifyChangeListeners(PropertyChangeEvent event) {
        if (event instanceof AssociationChangedEvent) {
            propertyChangeSupport.fireAssociationChange((AssociationChangedEvent)event);
        } else {
            propertyChangeSupport.firePropertyChange(event);
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void addPropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void addPropertyChangeListener(PropertyChangeListener listener, boolean propagateEventsFromChildren) {
        propertyChangeSupport.addPropertyChangeListener(listener, propagateEventsFromChildren);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public boolean hasListeners(String propertyName) {
        return propertyChangeSupport.hasListeners(propertyName);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(propertyName, listener);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void initFromXml(Element objectEl,
            boolean initWithProductDefaultsBeforeReadingXmlData,
            IRuntimeRepository productRepository,
            IObjectReferenceStore store,
            XmlCallback xmlCallback,
            String currPath) {
        productConfiguration.initFromXml(objectEl, productRepository);
        if (initWithProductDefaultsBeforeReadingXmlData) {
            initialize();
        }
        super.initFromXml(objectEl, initWithProductDefaultsBeforeReadingXmlData, productRepository, store, xmlCallback,
                currPath);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void initPropertiesFromXml(Map<String, String> propMap, IRuntimeRepository productRepository) {
        super.initPropertiesFromXml(propMap, productRepository);
        doInitJahresbasisbeitrag(propMap);
    }

    /**
     * @generated
     */
    private void doInitJahresbasisbeitrag(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_JAHRESBASISBEITRAG)) {
            this.jahresbasisbeitrag = Money.valueOf(propMap.get(PROPERTY_JAHRESBASISBEITRAG));
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected AbstractModelObject createChildFromXml(Element childEl) {
        AbstractModelObject newChild = super.createChildFromXml(childEl);
        if (newChild != null) {
            return newChild;
        }
        return null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public boolean accept(IModelObjectVisitor visitor) {
        if (!visitor.visit(this)) {
            return false;
        }
        return true;
    }

    /**
     * Validierung von Objekten der Klasse Deckung. Gibt <code>true</code> zurueck, wenn dieses
     * Objekt mit der Validierung fortfahren soll, <code>false</code> sonst.
     * 
     * @generated
     */
    @Override
    public boolean validateSelf(MessageList ml, IValidationContext context) {
        if (!super.validateSelf(ml, context)) {
            return STOP_VALIDATION;
        }
        return CONTINUE_VALIDATION;
    }

    /**
     * Validierung von abhaengigen Objekten fuer Instanzen der Klasse Deckung.
     * 
     * @generated
     */
    @Override
    public void validateDependants(MessageList ml, IValidationContext context) {
        super.validateDependants(ml, context);
    }

}
