package org.faktorips.tutorial.hausrat.hausrat;

import org.faktorips.runtime.ClassloaderRuntimeRepository;
import org.faktorips.runtime.IRuntimeRepository;
 
/**
 * Diese Klasse bietet Zugriff auf das FaktorIPS Runtime Repository.
 * 
 * <p>
 * Das Ablegen der {@code RuntimeRepositoryFactory} im gleichen Eclipse plug-in
 * Projekt wie das TOC-File stellt sicher, dass der Classloader
 * die XML Resourcen findet.
 */
public class HausratModellRuntimeRepositoryFactory {

	/** Pfad zum FaktorIPS repository. */
	static final String REPOSITORY_TOC_XML = "org/faktorips/tutorial/hausrat/"
			+ "internal/faktorips-repository-toc.xml";

	/**
	 * 
	 * Gibt das FaktorIPS Runtime-Repository zurück, dass die im Tutorial
	 * erstellte Produktkonfiguration enthält.
	 * 
	 * @return The {@code IRuntimeRepository}.
	 */
	public static IRuntimeRepository createRuntimeRepository(IRuntimeRepository baseModellRepository) {
		IRuntimeRepository repository = ClassloaderRuntimeRepository.create(
				HausratModellRuntimeRepositoryFactory.REPOSITORY_TOC_XML,
				HausratModellRuntimeRepositoryFactory.class.getClassLoader());
		repository.addDirectlyReferencedRepository(baseModellRepository);
		return repository;
	}
}
