/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.hausrat;

import java.util.Calendar;
import java.util.Collection;
import java.util.List;

import org.faktorips.runtime.CardinalityRange;
import org.faktorips.runtime.IProductComponentLink;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.tutorial.modell.base.IProduktGen;
import org.faktorips.values.Money;
import org.faktorips.valueset.IntegerRange;
import org.faktorips.valueset.MoneyRange;

/**
 * Die Generation von HausratProdukt.
 * 
 * @generated
 */
public interface IHausratProduktGen extends IProduktGen {

    /**
     * Diese Konstante enthaelt den Namen der Property vorschlagVersSummeProQm.
     * 
     * @generated
     */
    public final static String PROPERTY_VORSCHLAGVERSSUMMEPROQM = "vorschlagVersSummeProQm";

    /**
     * Gibt den Wert der Eigenschaft vorschlagVersSummeProQm zurueck.
     * <p>
     * Vorschlag für die Versicherungssumme für einen Quadratmeter Wohnfläche.
     * 
     * @generated
     */
    public Money getVorschlagVersSummeProQm();

    /**
     * Gibt den Defaultwert fuer die Eigenschaft wohnflaeche zurueck.
     * 
     * @generated
     */
    public Integer getDefaultValueWohnflaeche();

    /**
     * Gibt den erlaubten Wertebereich fuer das Attribut wohnflaeche zurueck.
     * 
     * @generated
     */
    public IntegerRange getRangeForWohnflaeche(IValidationContext context);

    /**
     * Gibt den Defaultwert fuer die Eigenschaft versSumme zurueck.
     * 
     * @generated
     */
    public Money getDefaultValueVersSumme();

    /**
     * Gibt den erlaubten Wertebereich fuer das Attribut versSumme zurueck.
     * 
     * @generated
     */
    public MoneyRange getRangeForVersSumme(IValidationContext context);

    /**
     * Gibt HausratGrunddeckungstyp zurueck. bzw. <null>, wenn kein Objekt referenziert wird.
     * 
     * @throws org.faktorips.runtime.ProductCmptNotFoundException wenn der referenzierte Baustein
     *             nicht gefunden wird.
     * 
     * @generated
     */
    public IHausratGrunddeckungstyp getHausratGrunddeckungstyp();

    /**
     * Gibt die zum gegebenen Zeitpunkt gueltige Generation HausratGrunddeckungstyp zurueck; bzw.
     * <null>, wenn kein Objekt referenziert wird.
     * 
     * @throws org.faktorips.runtime.ProductCmptNotFoundException wenn der referenzierte Baustein
     *             nicht gefunden wird.
     * 
     * @generated
     */
    public IHausratGrunddeckungstypGen getHausratGrunddeckungstyp(Calendar effectiveDate);

    /**
     * Gibt den <code>ILink</code> zu HausratGrunddeckungstyp zurueck. bzw. <null>, wenn kein Objekt
     * referenziert wird.
     * 
     * @generated
     */
    public IProductComponentLink<IHausratGrunddeckungstyp> getLinkForHausratGrunddeckungstyp();

    /**
     * Gibt den <code>ILink</code> zu HausratGrunddeckungstyp an dem angegebenen Index zurueck.
     * 
     * @generated
     */
    public IProductComponentLink<IHausratGrunddeckungstyp> getLinkForHausratGrunddeckungstyp(IHausratGrunddeckungstyp productComponent);

    /**
     * Gibt die Kardinalitaet fuer die Beziehung mit den Rollennamen HausratGrunddeckung zurueck.
     * 
     * @generated
     */
    public CardinalityRange getCardinalityForHausratGrunddeckung(IHausratGrunddeckungstyp productCmpt);

    /**
     * Gibt die referenzierten HausratZusatzdeckungstypen zurueck. Gibt ein leeres Array zurueck,
     * wenn kein Objekt referenziert wird.
     * 
     * @throws org.faktorips.runtime.ProductCmptNotFoundException wenn einer der referenzierten
     *             Bausteine nicht gefunden wird.
     * 
     * @generated
     */
    public List<? extends IHausratZusatzdeckungstyp> getHausratZusatzdeckungstypen();

    /**
     * Gibt die zum gegebenen Datum gueltigen referenzierten HausratZusatzdeckungstypen zurueck.
     * Gibt ein leeres Array zurueck, wenn kein Objekt referenziert wird.
     * 
     * @throws org.faktorips.runtime.ProductCmptNotFoundException wenn einer der referenzierten
     *             Bausteine nicht gefunden wird.
     * 
     * @generated
     */
    public List<? extends IHausratZusatzdeckungstypGen> getHausratZusatzdeckungstypen(Calendar effectiveDate);

    /**
     * Gibt HausratZusatzdeckungstyp an dem angegebenen Index zurueck.
     * 
     * @throws org.faktorips.runtime.ProductCmptNotFoundException wenn der referenzierten Baustein
     *             nicht gefunden wird.
     * 
     * @generated
     */
    public IHausratZusatzdeckungstyp getHausratZusatzdeckungstyp(int index);

    /**
     * Gibt die <code>ILink</code>s zu den referenzierten HausratZusatzdeckungstypen zurueck. Gibt
     * eine leere <code>Collection</code> zurueck, wenn kein Objekt referenziert wird.
     * 
     * @generated
     */
    public Collection<IProductComponentLink<IHausratZusatzdeckungstyp>> getLinksForHausratZusatzdeckungstypen();

    /**
     * Gibt den <code>ILink</code> zu HausratZusatzdeckungstyp an dem angegebenen Index zurueck.
     * 
     * @generated
     */
    public IProductComponentLink<IHausratZusatzdeckungstyp> getLinkForHausratZusatzdeckungstyp(IHausratZusatzdeckungstyp productComponent);

    /**
     * Gibt die Kardinalitaet fuer die Beziehung mit den Rollennamen HausratZusatzdeckung zurueck.
     * 
     * @generated
     */
    public CardinalityRange getCardinalityForHausratZusatzdeckung(IHausratZusatzdeckungstyp productCmpt);

    /**
     * Gibt die Anzahl der HausratZusatzdeckungstypen zurueck.
     * 
     * @generated
     */
    public int getNumOfHausratZusatzdeckungstypen();

    /**
     * Gibt HausratProdukt zurueck, zu dem diese Generation gehoert.
     * 
     * @generated
     */
    public IHausratProdukt getHausratProdukt();

    /**
     * Erzeugt und initialisiert eine neues Vertragsteil, das durch diese ProductComponentGeneration
     * konfiguriert wird. Das neue Vertragsteil in wird keiner Struktur eingefügt.
     * 
     * @generated
     */
    public IHausratVertrag createHausratVertrag();

}
