/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.hausrat;

import java.util.List;

import org.faktorips.runtime.IValidationContext;
import org.faktorips.tutorial.modell.base.IVertrag;
import org.faktorips.values.Money;
import org.faktorips.valueset.IntegerRange;
import org.faktorips.valueset.MoneyRange;

/**
 * Published Interface von HausratVertrag.
 * 
 * @generated
 */
public interface IHausratVertrag extends IVertrag {

    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft plz.
     * 
     * @generated
     */
    public final static String PROPERTY_PLZ = "plz";
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft tarifzone.
     * 
     * @generated
     */
    public final static String PROPERTY_TARIFZONE = "tarifzone";
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft wohnflaeche.
     * 
     * @generated
     */
    public final static String PROPERTY_WOHNFLAECHE = "wohnflaeche";
    /**
     * Gibt den maximal erlaubten Wertebereich fuer die Eigenschaft wohnflaeche zurueck.
     * 
     * @generated
     */
    public static final IntegerRange MAX_ALLOWED_RANGE_FOR_WOHNFLAECHE = IntegerRange.valueOf(Integer.valueOf("0"),
            (Integer)null, (Integer)null, false);
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft vorschlagVersSumme.
     * 
     * @generated
     */
    public final static String PROPERTY_VORSCHLAGVERSSUMME = "vorschlagVersSumme";
    /**
     * Diese Konstante enthaelt den Namen der Eigenschaft versSumme.
     * 
     * @generated
     */
    public final static String PROPERTY_VERSSUMME = "versSumme";
    /**
     * Gibt den maximal erlaubten Wertebereich fuer die Eigenschaft versSumme zurueck.
     * 
     * @generated
     */
    public static final MoneyRange MAX_ALLOWED_RANGE_FOR_VERSSUMME = MoneyRange.valueOf(Money.valueOf("0EUR"),
            Money.NULL, Money.NULL, false);
    /**
     * Die maximale Multiplizitaet der Beziehung mit dem Rollennamen HausratGrunddeckung.
     * 
     * @generated
     */
    public static final IntegerRange MAX_MULTIPLICITY_OF_HAUSRATGRUNDDECKUNG = IntegerRange.valueOf(0, 1);
    /**
     * Diese Konstante enthaelt den Name der Beziehung hausratGrunddeckung.
     * 
     * @generated
     */
    public final static String ASSOCIATION_HAUSRATGRUNDDECKUNG = "hausratGrunddeckung";
    /**
     * Die maximale Multiplizitaet der Beziehung mit dem Rollennamen HausratZusatzdeckung.
     * 
     * @generated
     */
    public static final IntegerRange MAX_MULTIPLICITY_OF_HAUSRATZUSATZDECKUNG = IntegerRange.valueOf(0, 2147483647);
    /**
     * Diese Konstante enthaelt den Name der Beziehung hausratZusatzdeckungen.
     * 
     * @generated
     */
    public final static String ASSOCIATION_HAUSRATZUSATZDECKUNGEN = "hausratZusatzdeckungen";

    /**
     * Gibt den Wert des Attributs plz zurueck.
     * 
     * @generated
     */
    public String getPlz();

    /**
     * Setzt den Wert des Attributs plz.
     * 
     * @generated
     */
    public void setPlz(String newValue);

    /**
     * Gibt den Wert des Attributs tarifzone zurueck.
     * 
     * @generated
     */
    public String getTarifzone();

    /**
     * Gibt den Wert des Attributs wohnflaeche zurueck.
     * <p>
     * Wohnfläche
     * 
     * @generated
     */
    public Integer getWohnflaeche();

    /**
     * Setzt den Wert des Attributs wohnflaeche.
     * <p>
     * Wohnfläche
     * 
     * @generated
     */
    public void setWohnflaeche(Integer newValue);

    /**
     * Gibt den erlaubten Wertebereich fuer das Attribut wohnflaeche zurueck.
     * 
     * @generated
     */
    public IntegerRange getRangeForWohnflaeche(IValidationContext context);

    /**
     * Gibt den Wert des Attributs vorschlagVersSumme zurueck.
     * <p>
     * Vorschlag Versicherungssumme pro qm
     * 
     * @generated
     */
    public Money getVorschlagVersSumme();

    /**
     * Gibt den Wert des Attributs versSumme zurueck.
     * <p>
     * Versicherungssumme
     * 
     * @generated
     */
    public Money getVersSumme();

    /**
     * Setzt den Wert des Attributs versSumme.
     * <p>
     * Versicherungssumme
     * 
     * @generated
     */
    public void setVersSumme(Money newValue);

    /**
     * Gibt den erlaubten Wertebereich fuer das Attribut versSumme zurueck.
     * 
     * @generated
     */
    public MoneyRange getRangeForVersSumme(IValidationContext context);

    /**
     * Gibt das referenzierte HausratGrunddeckung-Objekt zurueck.
     * 
     * @generated
     */
    public IHausratGrunddeckung getHausratGrunddeckung();

    /**
     * Setzt das uebergebene Objekt in der Beziehung HausratGrunddeckung.
     * 
     * @throws ClassCastException Wenn die Beziehung eingeschränkt wurde und das uebergebene Objekt
     *             nicht vom passenden Typ ist.
     * 
     * @generated
     */
    public void setHausratGrunddeckung(IHausratGrunddeckung newObject);

    /**
     * Erzeugt ein neues HausratGrunddeckung-Objekt und fuegt es zu diesem Objekt in der Rolle
     * HausratGrunddeckung hinzu.
     * 
     * @generated
     */
    public IHausratGrunddeckung newHausratGrunddeckung();

    /**
     * Erzeugt ein neues HausratGrunddeckung-Objekt und fuegt es zu diesem Objekt in der Rolle
     * HausratGrunddeckung hinzu.
     * 
     * @param iHausratGrunddeckungstyp Der Produktbaustein, auf dem das neue Objekt basiert.
     * 
     * @generated
     */
    public IHausratGrunddeckung newHausratGrunddeckung(IHausratGrunddeckungstyp iHausratGrunddeckungstyp);

    /**
     * Gibt die Anzahl der HausratZusatzdeckungen zurueck.
     * 
     * @generated
     */
    public int getNumOfHausratZusatzdeckungen();

    /**
     * Gibt <code>true</code> zurueck, falls das uebergebene Objekt in der Beziehung enthalten ist,
     * ansonsten <code>false</code>.
     * 
     * @generated
     */
    public boolean containsHausratZusatzdeckung(IHausratZusatzdeckung objectToTest);

    /**
     * Gibt die referenzierten HausratZusatzdeckungen zurueck.
     * 
     * @generated
     */
    public List<? extends IHausratZusatzdeckung> getHausratZusatzdeckungen();

    /**
     * Fuegt das uebergebene Objekt zu der Beziehung HausratZusatzdeckung hinzu.
     * 
     * @throws ClassCastException Wenn die Beziehung eingeschränkt wurde und das uebergebene Objekt
     *             nicht vom passenden Typ ist.
     * 
     * @generated
     */
    public void addHausratZusatzdeckung(IHausratZusatzdeckung objectToAdd);

    /**
     * Entfernt das uebergebene Objekt aus der Beziehung HausratZusatzdeckung.
     * 
     * @generated
     */
    public void removeHausratZusatzdeckung(IHausratZusatzdeckung objectToRemove);

    /**
     * Erzeugt ein neues HausratZusatzdeckung-Objekt und fuegt es zu diesem Objekt in der Rolle
     * HausratZusatzdeckung hinzu.
     * 
     * @generated
     */
    public IHausratZusatzdeckung newHausratZusatzdeckung();

    /**
     * Erzeugt ein neues HausratZusatzdeckung-Objekt und fuegt es zu diesem Objekt in der Rolle
     * HausratZusatzdeckung hinzu.
     * 
     * @param iHausratZusatzdeckungstyp Der Produktbaustein, auf dem das neue Objekt basiert.
     * 
     * @generated
     */
    public IHausratZusatzdeckung newHausratZusatzdeckung(IHausratZusatzdeckungstyp iHausratZusatzdeckungstyp);

    /**
     * Gibt das Objekt aus der Beziehung HausratZusatzdeckung an der indizierten Stelle zurueck.
     * 
     * @generated
     */
    public IHausratZusatzdeckung getHausratZusatzdeckung(int index);

    /**
     * @generated
     */
    public void ermittleVorschlagVersicherungssumme();

    /**
     * Gibt HausratProdukt zurueck, welches HausratVertrag konfiguriert.
     * 
     * @generated
     */
    public IHausratProdukt getHausratProdukt();

    /**
     * Setzt neuen HausratProdukt.
     * 
     * @param hausratProdukt Der neue HausratProdukt.
     * @param initPropertiesWithConfiguratedDefaults <code>true</code> falls die Eigenschaften mit
     *            den Defaultwerte aus HausratProdukt belegt werden sollen.
     * 
     * @generated
     */
    public void setHausratProdukt(IHausratProdukt hausratProdukt, boolean initPropertiesWithConfiguratedDefaults);

    /**
     * Gibt Generation zurueck, welches HausratProdukt konfiguriert. Generation wird anhand des
     * Wirksamkeitsdatum ermittelt.
     * 
     * @generated
     */
    public IHausratProduktGen getHausratProduktGen();

}
