/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;

import org.faktorips.runtime.CardinalityRange;
import org.faktorips.runtime.IProductComponent;
import org.faktorips.runtime.IProductComponentLink;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.runtime.IllegalRepositoryModificationException;
import org.faktorips.runtime.internal.ProductComponentLink;
import org.faktorips.runtime.internal.Range;
import org.faktorips.runtime.internal.ValueToXmlHelper;
import org.faktorips.runtime.internal.IpsStringUtils;
import org.faktorips.tutorial.hausrat.hausrat.IHausratGrunddeckungstyp;
import org.faktorips.tutorial.hausrat.hausrat.IHausratGrunddeckungstypGen;
import org.faktorips.tutorial.hausrat.hausrat.IHausratProdukt;
import org.faktorips.tutorial.hausrat.hausrat.IHausratProduktGen;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstyp;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstypGen;
import org.faktorips.tutorial.modell.base.IDeckungstyp;
import org.faktorips.tutorial.modell.internal.base.ProduktGen;
import org.faktorips.values.Money;
import org.faktorips.valueset.IntegerRange;
import org.faktorips.valueset.MoneyRange;
import org.w3c.dom.Element;
import org.faktorips.tutorial.hausrat.hausrat.IHausratVertrag;

/**
 * Die Implementierung von IHausratProduktGen.
 * 
 * @generated
 */
public class HausratProduktGen extends ProduktGen implements IHausratProduktGen {

    /**
     * Der XML Tag Name der Assoziation hausratGrunddeckungstyp.
     * 
     * @generated
     */
    private static final String XML_TAG_HAUSRAT_GRUNDDECKUNGSTYP = "HausratGrunddeckungstyp";

    /**
     * Der XML Tag Name der Assoziation hausratZusatzdeckungstypen.
     * 
     * @generated
     */
    private static final String XML_TAG_HAUSRAT_ZUSATZDECKUNGSTYPEN = "HausratZusatzdeckungstyp";

    /**
     * Membervariable fuer die Produkteigenschaft VorschlagVersSummeProQm.
     * 
     * @generated
     */
    private Money vorschlagVersSummeProQm;

    /**
     * Membervariable fuer den Vorgabewert der Vertragseigenschaft wohnflaeche.
     * 
     * @generated
     */
    private Integer defaultValueWohnflaeche = null;

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getVorschlagVersSummeProQm() {
        return vorschlagVersSummeProQm;
    }

    /**
     * Setzt den Wert der Eigenschaft vorschlagVersSummeProQm.
     * 
     * @generated
     */
    public void setVorschlagVersSummeProQm(Money newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setVorschlagVersSummeProQmInternal(newValue);
    }

    /**
     * Setzt den Wert des Attributs vorschlagVersSummeProQm, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setVorschlagVersSummeProQmInternal(Money newValue) {
        this.vorschlagVersSummeProQm = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Integer getDefaultValueWohnflaeche() {
        return defaultValueWohnflaeche;
    }

    /**
     * Instanzvariable fuer den Wertebereich des Attributs wohnflaeche.
     * 
     * @generated
     */
    private IntegerRange rangeForWohnflaeche;

    /**
     * Membervariable fuer den Vorgabewert der Vertragseigenschaft versSumme.
     * 
     * @generated
     */
    private Money defaultValueVersSumme = Money.NULL;
    /**
     * Instanzvariable fuer den Wertebereich des Attributs versSumme.
     * 
     * @generated
     */
    private MoneyRange rangeForVersSumme;

    /**
     * Membervariable fuer die Beziehung HausratGrunddeckungstyp.
     * 
     * @generated
     */
    private IProductComponentLink<IHausratGrunddeckungstyp> hausratGrunddeckungstyp = null;
    /**
     * Membervariable fuer die Beziehung HausratZusatzdeckungstypen.
     * 
     * @generated
     */
    private Map<String, IProductComponentLink<IHausratZusatzdeckungstyp>> hausratZusatzdeckungstypen = new LinkedHashMap<String, IProductComponentLink<IHausratZusatzdeckungstyp>>(
            0);

    /**
     * Erzeugt eine neue Instanz von HausratProduktGen.
     * 
     * @generated
     */
    public HausratProduktGen(HausratProdukt productCmpt) {
        super(productCmpt);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IntegerRange getRangeForWohnflaeche(IValidationContext context) {
        return rangeForWohnflaeche;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getDefaultValueVersSumme() {
        return defaultValueVersSumme;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public MoneyRange getRangeForVersSumme(IValidationContext context) {
        return rangeForVersSumme;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratGrunddeckungstyp getHausratGrunddeckungstyp() {
        return hausratGrunddeckungstyp != null ? hausratGrunddeckungstyp.getTarget() : null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratGrunddeckungstypGen getHausratGrunddeckungstyp(Calendar effectiveDate) {
        return hausratGrunddeckungstyp != null ? hausratGrunddeckungstyp.getTarget().getHausratGrunddeckungstypGen(
                effectiveDate) : null;
    }

    /**
     * Setzt das neue referenzierte HausratGrunddeckungstyp-Objekt.
     * 
     * @generated
     */
    public void setHausratGrunddeckungstyp(IHausratGrunddeckungstyp target) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        hausratGrunddeckungstyp = (target == null ? null : new ProductComponentLink<IHausratGrunddeckungstyp>(this,
                target));
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentLink<IHausratGrunddeckungstyp> getLinkForHausratGrunddeckungstyp() {
        return hausratGrunddeckungstyp;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentLink<IHausratGrunddeckungstyp> getLinkForHausratGrunddeckungstyp(IHausratGrunddeckungstyp productComponent) {
        return hausratGrunddeckungstyp.getTargetId().equals(productComponent.getId()) ? hausratGrunddeckungstyp : null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public CardinalityRange getCardinalityForHausratGrunddeckung(IHausratGrunddeckungstyp productCmpt) {
        if (productCmpt != null) {
            return hausratGrunddeckungstyp != null && hausratGrunddeckungstyp.getTargetId().equals(productCmpt.getId()) ? hausratGrunddeckungstyp
                    .getCardinality()
                    : null;
        }
        return null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<? extends IHausratZusatzdeckungstyp> getHausratZusatzdeckungstypen() {
        List<IHausratZusatzdeckungstyp> result = new ArrayList<IHausratZusatzdeckungstyp>(hausratZusatzdeckungstypen
                .size());
        for (IProductComponentLink<IHausratZusatzdeckungstyp> hausratZusatzdeckungstyp : hausratZusatzdeckungstypen
                .values()) {
            result.add(hausratZusatzdeckungstyp.getTarget());
        }
        return result;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<? extends IHausratZusatzdeckungstypGen> getHausratZusatzdeckungstypen(Calendar effectiveDate) {
        List<? extends IHausratZusatzdeckungstyp> targets = getHausratZusatzdeckungstypen();
        List<IHausratZusatzdeckungstypGen> result = new ArrayList<IHausratZusatzdeckungstypGen>();
        for (IHausratZusatzdeckungstyp target : targets) {
            IHausratZusatzdeckungstypGen gen = target.getHausratZusatzdeckungstypGen(effectiveDate);
            if (gen != null) {
                result.add(gen);
            }
        }
        return result;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckungstyp getHausratZusatzdeckungstyp(int index) {
        Iterator<IProductComponentLink<IHausratZusatzdeckungstyp>> it = hausratZusatzdeckungstypen.values().iterator();
        try {
            for (int i = 0; i < index; i++) {
                it.next();
            }
            return it.next().getTarget();
        } catch (NoSuchElementException e) {
            throw new IndexOutOfBoundsException(e.getLocalizedMessage());
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Collection<IProductComponentLink<IHausratZusatzdeckungstyp>> getLinksForHausratZusatzdeckungstypen() {
        return Collections.unmodifiableCollection(hausratZusatzdeckungstypen.values());
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentLink<IHausratZusatzdeckungstyp> getLinkForHausratZusatzdeckungstyp(IHausratZusatzdeckungstyp productComponent) {
        return hausratZusatzdeckungstypen.get(productComponent.getId());
    }

    /**
     * Fuegt den gegebenen Produktbaustein zu diesem hinzu.
     * 
     * @generated
     */
    public void addHausratZusatzdeckungstyp(IHausratZusatzdeckungstyp target) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        this.hausratZusatzdeckungstypen.put(target.getId(), new ProductComponentLink<IHausratZusatzdeckungstyp>(this,
                target));
    }

    /**
     * Fuegt den gegebenen Produktbaustein mit der gegebenen Kardinalitaet zu diesem hinzu.
     * 
     * @generated
     */
    public void addHausratZusatzdeckungstyp(IHausratZusatzdeckungstyp target, CardinalityRange cardinality) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        this.hausratZusatzdeckungstypen.put(target.getId(), new ProductComponentLink<IHausratZusatzdeckungstyp>(this,
                target, cardinality));
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public CardinalityRange getCardinalityForHausratZusatzdeckung(IHausratZusatzdeckungstyp productCmpt) {
        if (productCmpt != null) {
            return hausratZusatzdeckungstypen.containsKey(productCmpt.getId()) ? hausratZusatzdeckungstypen.get(
                    productCmpt.getId()).getCardinality() : null;
        }
        return null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public int getNumOfHausratZusatzdeckungstypen() {
        return hausratZusatzdeckungstypen.size();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<IDeckungstyp> getDeckungstypen() {
        List<IDeckungstyp> result = new ArrayList<IDeckungstyp>(getNumOfDeckungstypenInternal());
        if (hausratGrunddeckungstyp != null) {
            result.add(getHausratGrunddeckungstyp());
        }
        result.addAll(getHausratZusatzdeckungstypen());
        return result;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public int getNumOfDeckungstypen() {
        return getNumOfDeckungstypenInternal();
    }

    /**
     * @generated
     */
    private int getNumOfDeckungstypenInternal() {
        int num = 0;
        num += hausratGrunddeckungstyp == null ? 0 : 1;
        num += getNumOfHausratZusatzdeckungstypen();
        return num;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratProdukt getHausratProdukt() {
        return (IHausratProdukt)getProductComponent();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void doInitPropertiesFromXml(Map<String, Element> configMap) {
        super.doInitPropertiesFromXml(configMap);
        doInitVorschlagVersSummeProQm(configMap);
        doInitWohnflaeche(configMap);
        doInitVersSumme(configMap);
    }

    /**
     * @generated
     */
    private void doInitVorschlagVersSummeProQm(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_VORSCHLAGVERSSUMMEPROQM);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.vorschlagVersSummeProQm = Money.valueOf(value);
        }
    }

    /**
     * @generated
     */
    private void doInitWohnflaeche(Map<String, Element> configMap) {
        Element configElement = configMap.get(HausratVertrag.PROPERTY_WOHNFLAECHE);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            defaultValueWohnflaeche = IpsStringUtils.isEmpty(value) ? null : Integer.valueOf(value);
            Range range = ValueToXmlHelper.getRangeFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE_SET);
            if (range != null) {
                rangeForWohnflaeche = IntegerRange.valueOf(range.getLower(), range.getUpper(), range.getStep(), range
                        .containsNull());
            }
        }
    }

    /**
     * @generated
     */
    private void doInitVersSumme(Map<String, Element> configMap) {
        Element configElement = configMap.get(HausratVertrag.PROPERTY_VERSSUMME);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            defaultValueVersSumme = Money.valueOf(value);
            Range range = ValueToXmlHelper.getRangeFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE_SET);
            if (range != null) {
                rangeForVersSumme = MoneyRange.valueOf(range.getLower(), range.getUpper(), range.getStep(), range
                        .containsNull());
            }
        }
    }

    /**
     * @generated
     */
    @Override
    protected void doInitReferencesFromXml(Map<String, List<Element>> elementsMap) {
        super.doInitReferencesFromXml(elementsMap);
        doInitHausratGrunddeckungstyp(elementsMap);
        doInitHausratZusatzdeckungstyp(elementsMap);
    }

    /**
     * @generated
     */
    private void doInitHausratGrunddeckungstyp(Map<String, List<Element>> elementsMap) {
        List<Element> associationElements = elementsMap.get(XML_TAG_HAUSRAT_GRUNDDECKUNGSTYP);
        if (associationElements != null) {
            Element element = associationElements.get(0);
            hausratGrunddeckungstyp = new ProductComponentLink<IHausratGrunddeckungstyp>(this);
            hausratGrunddeckungstyp.initFromXml(element);
        }
    }

    /**
     * @generated
     */
    private void doInitHausratZusatzdeckungstyp(Map<String, List<Element>> elementsMap) {
        List<Element> associationElements = elementsMap.get(XML_TAG_HAUSRAT_ZUSATZDECKUNGSTYPEN);
        if (associationElements != null) {
            this.hausratZusatzdeckungstypen = new LinkedHashMap<String, IProductComponentLink<IHausratZusatzdeckungstyp>>(
                    associationElements.size());
            for (Element element : associationElements) {
                IProductComponentLink<IHausratZusatzdeckungstyp> link = new ProductComponentLink<IHausratZusatzdeckungstyp>(
                        this);
                link.initFromXml(element);
                this.hausratZusatzdeckungstypen.put(link.getTargetId(), link);
            }
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratVertrag createHausratVertrag() {
        HausratVertrag policy = new HausratVertrag(getHausratProdukt());
        policy.setProductCmptGeneration(this);
        policy.initialize();
        return policy;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratVertrag createPolicyComponent() {
        return createHausratVertrag();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentLink<? extends IProductComponent> getLink(String linkName, IProductComponent target) {
        if ("HausratGrunddeckungstyp".equals(linkName)) {
            return getLinkForHausratGrunddeckungstyp((IHausratGrunddeckungstyp)target);
        }
        if ("HausratZusatzdeckungstyp".equals(linkName)) {
            return getLinkForHausratZusatzdeckungstyp((IHausratZusatzdeckungstyp)target);
        }
        return super.getLink(linkName, target);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<IProductComponentLink<? extends IProductComponent>> getLinks() {
        List<IProductComponentLink<? extends IProductComponent>> list = super.getLinks();
        if (getLinkForHausratGrunddeckungstyp() != null) {
            list.add(getLinkForHausratGrunddeckungstyp());
        }
        list.addAll(getLinksForHausratZusatzdeckungstypen());
        return list;
    }

}
