/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.beans.PropertyChangeEvent;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

import org.faktorips.runtime.AssociationChangedEvent;
import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.internal.IpsStringUtils;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.runtime.MessageList;

import org.faktorips.runtime.internal.AbstractModelObject;
import org.faktorips.tutorial.hausrat.hausrat.IHausratGrunddeckung;
import org.faktorips.tutorial.hausrat.hausrat.IHausratGrunddeckungstyp;
import org.faktorips.tutorial.hausrat.hausrat.IHausratProdukt;
import org.faktorips.tutorial.hausrat.hausrat.IHausratProduktGen;
import org.faktorips.tutorial.hausrat.hausrat.IHausratVertrag;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckung;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstyp;
import org.faktorips.tutorial.modell.base.IDeckung;
import org.faktorips.tutorial.modell.internal.base.Vertrag;
import org.faktorips.values.Money;
import org.faktorips.valueset.IntegerRange;
import org.faktorips.valueset.MoneyRange;
import org.w3c.dom.Element;

/**
 * Implementierung von IHausratVertrag.
 * 
 * @generated
 */
@XmlRootElement(name = "HausratVertrag")
public class HausratVertrag extends Vertrag implements IHausratVertrag {

    /**
     * Membervariable fuer plz.
     * 
     * @generated
     */
    @XmlElement(name = "plz", nillable = true)
    private String plz = null;

    /**
     * Membervariable fuer wohnflaeche.
     * 
     * @generated
     */
    @XmlElement(name = "wohnflaeche", nillable = true)
    private Integer wohnflaeche = null;

    /**
     * Membervariable fuer vorschlagVersSumme.
     * 
     * @generated
     */
    @XmlElement(name = "vorschlagVersSumme", nillable = true)
    private Money vorschlagVersSumme = Money.NULL;

    /**
     * Membervariable fuer versSumme.
     * 
     * @generated
     */
    @XmlElement(name = "versSumme", nillable = true)
    private Money versSumme = Money.NULL;

    /**
     * Membervariable fuer die Beziehung HausratGrunddeckung.
     * 
     * @generated
     */
    @XmlElement(name = "HausratGrunddeckung", type = org.faktorips.tutorial.hausrat.internal.hausrat.HausratGrunddeckung.class)
    private HausratGrunddeckung hausratGrunddeckung = null;
    /**
     * Membervariable fuer die Beziehung HausratZusatzdeckung.
     * 
     * @generated
     */
    @XmlElement(name = "HausratZusatzdeckung", type = org.faktorips.tutorial.hausrat.internal.hausrat.HausratZusatzdeckung.class)
    @XmlElementWrapper(name = "HausratZusatzdeckungen")
    private List<IHausratZusatzdeckung> hausratZusatzdeckungen = new ArrayList<IHausratZusatzdeckung>();

    /**
     * Erzeugt eine neue Instanz von HausratVertrag.
     * 
     * @generated
     */
    public HausratVertrag() {
        super();
    }

    /**
     * Erzeugt eine neue Instanz von HausratVertrag.
     * 
     * @generated
     */
    public HausratVertrag(IHausratProdukt productCmpt) {
        super(productCmpt);
    }

    /**
     * Gibt den Wert des Attributs vorschlagVersSummeProQm zurueck.
     * <p>
     * Vorschlag für die Versicherungssumme für einen Quadratmeter Wohnfläche.
     * 
     * @generated
     */
    public Money getVorschlagVersSummeProQm() {
        return getHausratProduktGen().getVorschlagVersSummeProQm();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public String getPlz() {
        return plz;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated NOT
     */
    @Override
    public void setPlz(String newValue) {
        String oldPlz = plz;
        this.plz = newValue;
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_PLZ, oldPlz, plz));
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_TARIFZONE, null, getTarifzone()));
    }

    /**
     * Setzt den Wert des Attributs plz, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setPlzInternal(String newValue) {
        this.plz = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated NOT
     */
    @Override
    public String getTarifzone() {
        if (plz == null) {
            return "I";
        }
        IRuntimeRepository repository = getHausratProdukt().getRepository();
        Tarifzonentabelle tabelle = Tarifzonentabelle.getInstance(repository);
        TarifzonentabelleRow row = tabelle.findRow(plz);
        if (row == null) {
            return "I";
        }
        return row.getTarifzone();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IntegerRange getRangeForWohnflaeche(IValidationContext context) {
        return getHausratProduktGen().getRangeForWohnflaeche(context);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Integer getWohnflaeche() {
        return wohnflaeche;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setWohnflaeche(Integer newValue) {
        Integer oldWohnflaeche = wohnflaeche;
        setWohnflaecheInternal(newValue);
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_WOHNFLAECHE, oldWohnflaeche, wohnflaeche));
    }

    /**
     * Setzt den Wert des Attributs wohnflaeche, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setWohnflaecheInternal(Integer newValue) {
        this.wohnflaeche = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getVorschlagVersSumme() {
        return vorschlagVersSumme;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public MoneyRange getRangeForVersSumme(IValidationContext context) {
        return getHausratProduktGen().getRangeForVersSumme(context);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getVersSumme() {
        return versSumme;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setVersSumme(Money newValue) {
        Money oldVersSumme = versSumme;
        setVersSummeInternal(newValue);
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_VERSSUMME, oldVersSumme, versSumme));
    }

    /**
     * Setzt den Wert des Attributs versSumme, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setVersSummeInternal(Money newValue) {
        this.versSumme = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratGrunddeckung getHausratGrunddeckung() {
        return hausratGrunddeckung;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setHausratGrunddeckung(IHausratGrunddeckung newObject) {
        IHausratGrunddeckung oldHausratGrunddeckung = hausratGrunddeckung;
        setHausratGrunddeckungInternal(newObject);
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATGRUNDDECKUNG,
                oldHausratGrunddeckung, newObject));
    }

    /**
     * Setzt das uebergebene Objekt in der Beziehung HausratGrunddeckung ohne einen Change-Event
     * auszuloesen.
     * 
     * @throws ClassCastException Wenn die Beziehung eingeschränkt wurde und das uebergebene Objekt
     *             nicht vom passenden Typ ist.
     * 
     * @generated
     */
    public void setHausratGrunddeckungInternal(IHausratGrunddeckung newObject) {
        if (hausratGrunddeckung != null) {
            hausratGrunddeckung.setHausratVertragInternal(null);
        }
        if (newObject != null) {
            ((HausratGrunddeckung)newObject).setHausratVertragInternal(this);
        }
        hausratGrunddeckung = (HausratGrunddeckung)newObject;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratGrunddeckung newHausratGrunddeckung() {
        HausratGrunddeckung newHausratGrunddeckung = new HausratGrunddeckung();
        setHausratGrunddeckungInternal(newHausratGrunddeckung);
        newHausratGrunddeckung.initialize();
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATGRUNDDECKUNG, null,
                newHausratGrunddeckung));
        return newHausratGrunddeckung;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratGrunddeckung newHausratGrunddeckung(IHausratGrunddeckungstyp iHausratGrunddeckungstyp) {
        if (iHausratGrunddeckungstyp == null) {
            return newHausratGrunddeckung();
        }
        IHausratGrunddeckung newHausratGrunddeckung = iHausratGrunddeckungstyp.createHausratGrunddeckung();
        setHausratGrunddeckungInternal(newHausratGrunddeckung);
        newHausratGrunddeckung.initialize();
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATGRUNDDECKUNG, null,
                newHausratGrunddeckung));
        return newHausratGrunddeckung;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public int getNumOfHausratZusatzdeckungen() {
        return hausratZusatzdeckungen.size();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public boolean containsHausratZusatzdeckung(IHausratZusatzdeckung objectToTest) {
        return hausratZusatzdeckungen.contains(objectToTest);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<? extends IHausratZusatzdeckung> getHausratZusatzdeckungen() {
        return Collections.unmodifiableList(hausratZusatzdeckungen);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckung getHausratZusatzdeckung(int index) {
        return hausratZusatzdeckungen.get(index);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckung newHausratZusatzdeckung() {
        HausratZusatzdeckung newHausratZusatzdeckung = new HausratZusatzdeckung();
        addHausratZusatzdeckungInternal(newHausratZusatzdeckung);
        newHausratZusatzdeckung.initialize();
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATZUSATZDECKUNGEN, null,
                newHausratZusatzdeckung));
        return newHausratZusatzdeckung;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckung newHausratZusatzdeckung(IHausratZusatzdeckungstyp iHausratZusatzdeckungstyp) {
        if (iHausratZusatzdeckungstyp == null) {
            return newHausratZusatzdeckung();
        }
        IHausratZusatzdeckung newHausratZusatzdeckung = iHausratZusatzdeckungstyp.createHausratZusatzdeckung();
        addHausratZusatzdeckungInternal(newHausratZusatzdeckung);
        newHausratZusatzdeckung.initialize();
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATZUSATZDECKUNGEN, null,
                newHausratZusatzdeckung));
        return newHausratZusatzdeckung;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void addHausratZusatzdeckung(IHausratZusatzdeckung objectToAdd) {
        addHausratZusatzdeckungInternal(objectToAdd);
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATZUSATZDECKUNGEN, null, objectToAdd));
    }

    /**
     * Fuegt das uebergebene Objekt zu der Beziehung HausratZusatzdeckung hinzu, ohne einen
     * Change-Event auszuloesen.
     * 
     * @throws ClassCastException Wenn die Beziehung eingeschränkt wurde und das uebergebene Objekt
     *             nicht vom passenden Typ ist.
     * 
     * @generated
     */
    public void addHausratZusatzdeckungInternal(IHausratZusatzdeckung objectToAdd) {
        if (objectToAdd == null) {
            throw new NullPointerException("Can't add null to association HausratZusatzdeckung of " + this);
        }
        if (hausratZusatzdeckungen.contains(objectToAdd)) {
            return;
        }
        ((HausratZusatzdeckung)objectToAdd).setHausratVertragInternal(this);
        hausratZusatzdeckungen.add(objectToAdd);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void removeHausratZusatzdeckung(IHausratZusatzdeckung objectToRemove) {
        if (objectToRemove == null) {
            return;
        }
        if (hausratZusatzdeckungen.remove(objectToRemove)) {
            ((HausratZusatzdeckung)objectToRemove).setHausratVertragInternal(null);
        }
        notifyChangeListeners(new AssociationChangedEvent(this, ASSOCIATION_HAUSRATZUSATZDECKUNGEN, objectToRemove,
                null));
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public int getNumOfDeckungen() {
        return getNumOfDeckungenInternal();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<IDeckung> getDeckungen() {
        List<IDeckung> result = new ArrayList<IDeckung>(getNumOfDeckungenInternal());
        if (getHausratGrunddeckung() != null) {
            result.add(getHausratGrunddeckung());
        }
        result.addAll(getHausratZusatzdeckungen());
        return result;
    }

    /**
     * @generated
     */
    private int getNumOfDeckungenInternal() {
        int num = 0;
        num += hausratGrunddeckung == null ? 0 : 1;
        num += getNumOfHausratZusatzdeckungen();
        return num;
    }

    /**
     * 
     * @generated NOT
     */
    @Override
    public void ermittleVorschlagVersicherungssumme() {
        Money oldValue = vorschlagVersSumme;
        if (!Money.NULL.equals(getVorschlagVersSummeProQm())) {
            vorschlagVersSumme = getVorschlagVersSummeProQm().multiply(getWohnflaeche());
        }
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_VORSCHLAGVERSSUMME, oldValue, vorschlagVersSumme));
    }

    /**
     * Initialisiert Attribute mit ihren Vorgabewerten.
     * 
     * @restrainedmodifiable
     */
    @Override
    public void initialize() {
        super.initialize();
        if (getHausratProduktGen() == null) {
            return;
        }
        setWohnflaecheInternal(getHausratProduktGen().getDefaultValueWohnflaeche());
        setVersSummeInternal(getHausratProduktGen().getDefaultValueVersSumme());

        // begin-user-code
        // end-user-code
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratProdukt getHausratProdukt() {
        return (IHausratProdukt)getProductComponent();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratProduktGen getHausratProduktGen() {
        return (IHausratProduktGen)getProductCmptGeneration();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setHausratProdukt(IHausratProdukt hausratProdukt, boolean initPropertiesWithConfiguratedDefaults) {
        setProductComponent(hausratProdukt);
        if (initPropertiesWithConfiguratedDefaults) {
            initialize();
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void effectiveFromHasChanged() {
        super.effectiveFromHasChanged();
        if (hausratGrunddeckung != null) {
            hausratGrunddeckung.effectiveFromHasChanged();
        }
        for (Iterator<IHausratZusatzdeckung> it = hausratZusatzdeckungen.iterator(); it.hasNext();) {
            HausratZusatzdeckung child = (HausratZusatzdeckung)it.next();
            child.effectiveFromHasChanged();
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Calendar getEffectiveFromAsCalendar() {
        return super.getEffectiveFromAsCalendar();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void initPropertiesFromXml(Map<String, String> propMap, IRuntimeRepository productRepository) {
        super.initPropertiesFromXml(propMap, productRepository);
        doInitPlz(propMap);
        doInitWohnflaeche(propMap);
        doInitVorschlagVersSumme(propMap);
        doInitVersSumme(propMap);
    }

    /**
     * @generated
     */
    private void doInitPlz(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_PLZ)) {
            this.plz = propMap.get(PROPERTY_PLZ);
        }
    }

    /**
     * @generated
     */
    private void doInitWohnflaeche(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_WOHNFLAECHE)) {
            this.wohnflaeche = IpsStringUtils.isEmpty(propMap.get(PROPERTY_WOHNFLAECHE)) ? null : Integer
                    .valueOf(propMap.get(PROPERTY_WOHNFLAECHE));
        }
    }

    /**
     * @generated
     */
    private void doInitVorschlagVersSumme(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_VORSCHLAGVERSSUMME)) {
            this.vorschlagVersSumme = Money.valueOf(propMap.get(PROPERTY_VORSCHLAGVERSSUMME));
        }
    }

    /**
     * @generated
     */
    private void doInitVersSumme(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_VERSSUMME)) {
            this.versSumme = Money.valueOf(propMap.get(PROPERTY_VERSSUMME));
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected AbstractModelObject createChildFromXml(Element childEl) {
        AbstractModelObject newChild = super.createChildFromXml(childEl);
        if (newChild != null) {
            return newChild;
        }
        if ("HausratGrunddeckung".equals(childEl.getNodeName())) {
            return doInitHausratGrunddeckung(childEl);
        }
        if ("HausratZusatzdeckung".equals(childEl.getNodeName())) {
            return doInitHausratZusatzdeckung(childEl);
        }
        return null;
    }

    /**
     * @generated
     */
    private AbstractModelObject doInitHausratGrunddeckung(Element childEl) {
        String className = childEl.getAttribute("class");
        if (className.length() > 0) {
            try {
                HausratGrunddeckung hausratGrunddeckungLocalVar = (HausratGrunddeckung)Class.forName(className)
                        .newInstance();
                setHausratGrunddeckung(hausratGrunddeckungLocalVar);
                return hausratGrunddeckungLocalVar;
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return (AbstractModelObject)newHausratGrunddeckung();
    }

    /**
     * @generated
     */
    private AbstractModelObject doInitHausratZusatzdeckung(Element childEl) {
        String className = childEl.getAttribute("class");
        if (className.length() > 0) {
            try {
                HausratZusatzdeckung hausratZusatzdeckungLocalVar = (HausratZusatzdeckung)Class.forName(className)
                        .newInstance();
                addHausratZusatzdeckung(hausratZusatzdeckungLocalVar);
                return hausratZusatzdeckungLocalVar;
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return (AbstractModelObject)newHausratZusatzdeckung();
    }

    /**
     * Validierung von Objekten der Klasse HausratVertrag. Gibt <code>true</code> zurueck, wenn
     * dieses Objekt mit der Validierung fortfahren soll, <code>false</code> sonst.
     * 
     * @generated
     */
    @Override
    public boolean validateSelf(MessageList ml, IValidationContext context) {
        if (!super.validateSelf(ml, context)) {
            return STOP_VALIDATION;
        }
        return CONTINUE_VALIDATION;
    }

    /**
     * Validierung von abhaengigen Objekten fuer Instanzen der Klasse HausratVertrag.
     * 
     * @generated
     */
    @Override
    public void validateDependants(MessageList ml, IValidationContext context) {
        super.validateDependants(ml, context);
    }

}
