/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.beans.PropertyChangeEvent;
import java.math.BigDecimal;
import java.util.Map;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlRootElement;

import org.faktorips.runtime.IModelObject;
import org.faktorips.runtime.INotificationSupport;
import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.IValidationContext;
import org.faktorips.runtime.MessageList;
import org.faktorips.runtime.internal.AbstractModelObject;
import org.faktorips.tutorial.hausrat.hausrat.IHausratVertrag;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckung;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstyp;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstypGen;
import org.faktorips.tutorial.modell.base.IVertrag;
import org.faktorips.tutorial.modell.internal.base.Deckung;
import org.faktorips.values.Decimal;
import org.faktorips.values.Money;
import org.w3c.dom.Element;

/**
 * Implementierung von IHausratZusatzdeckung.
 * 
 * @generated
 */
@XmlRootElement(name = "HausratZusatzdeckung")
public class HausratZusatzdeckung extends Deckung implements IHausratZusatzdeckung {

    /**
     * Membervariable fuer versSumme.
     * 
     * @generated
     */
    @XmlElement(name = "versSumme", nillable = true)
    private Money versSumme = Money.NULL;

    /**
     * Membervariable fuer das Parent-Objekt: HausratVertrag.
     * 
     * @generated
     */
    @XmlAttribute(name = "hausratVertrag.id")
    @XmlIDREF
    private HausratVertrag hausratVertrag;

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckung.
     * 
     * @generated
     */
    public HausratZusatzdeckung() {
        super();
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckung.
     * 
     * @generated
     */
    public HausratZusatzdeckung(IHausratZusatzdeckungstyp productCmpt) {
        super(productCmpt);
    }

    /**
     * Gibt den Wert des Attributs versSummenFaktor zurueck.
     * <p>
     * Faktor, mit dem aus der Versicherungssumme der Grunddeckung die Versicherungssumme der
     * Zusatzdeckung ermittelt werden kann.
     * 
     * @generated
     */
    public Decimal getVersSummenFaktor() {
        return getHausratZusatzdeckungstypGen().getVersSummenFaktor();
    }

    /**
     * Gibt den Wert des Attributs maxVersSumme zurueck.
     * <p>
     * maximale Versicherungssumme (Deckelung)
     * 
     * @generated
     */
    public Money getMaxVersSumme() {
        return getHausratZusatzdeckungstypGen().getMaxVersSumme();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated NOT
     */
    @Override
    public Money getVersSumme() {
        ermittleVersSumme();
        return versSumme;
    }

    /**
     * {@inheritDoc}
     */
    public Money berechneJahresbasisbeitragInternal() {
        Money oldValue = getJahresbasisbeitrag();
        Money newValue = Money.NULL;
        ermittleVersSumme();
        IHausratZusatzdeckungstypGen hausratZusatzdeckungstypGen = getHausratZusatzdeckungstypGen();
        if (hausratZusatzdeckungstypGen != null) {
            newValue = hausratZusatzdeckungstypGen.berechneJahresbasisbeitrag(this, getHausratVertrag());
        }
        notifyChangeListeners(new PropertyChangeEvent(this, PROPERTY_JAHRESBASISBEITRAG, oldValue, newValue));
        return newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratVertrag getHausratVertrag() {
        return hausratVertrag;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated NOT
     */
    @Override
    public void ermittleVersSumme() {
        Money oldValue = versSumme;
        IHausratZusatzdeckungstypGen gen = getHausratZusatzdeckungstypGen();
        if (gen == null || getHausratVertrag() == null) {
            versSumme = Money.NULL;
        } else {
            Decimal faktor = gen.getVersSummenFaktor();
            Money vsVertrag = getHausratVertrag().getVersSumme();
            Money vs = vsVertrag.multiply(faktor, BigDecimal.ROUND_HALF_UP);

            Money maxVs = gen.getMaxVersSumme();
            if (vs.greaterThan(maxVs)) {
                versSumme = maxVs;
            } else {
                versSumme = vs;
            }
        }
        notifyChangeListeners(new PropertyChangeEvent(this, IHausratZusatzdeckung.PROPERTY_VERSSUMME, oldValue,
                versSumme));
    }

    public void propertyChange(PropertyChangeEvent evt) {
        if (IHausratZusatzdeckung.PROPERTY_VERSSUMME.equals(evt.getPropertyName())) {
            berechneJahresbasisbeitrag();
        }
    }

    /**
     * Initialisiert Attribute mit ihren Vorgabewerten.
     * 
     * @restrainedmodifiable
     */
    @Override
    public void initialize() {
        super.initialize();
        // begin-user-code
        // end-user-code
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckungstyp getHausratZusatzdeckungstyp() {
        return (IHausratZusatzdeckungstyp)getProductComponent();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckungstypGen getHausratZusatzdeckungstypGen() {
        return (IHausratZusatzdeckungstypGen)getProductCmptGeneration();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void setHausratZusatzdeckungstyp(IHausratZusatzdeckungstyp hausratZusatzdeckungstyp,
            boolean initPropertiesWithConfiguratedDefaults) {
        setProductComponent(hausratZusatzdeckungstyp);
        if (initPropertiesWithConfiguratedDefaults) {
            initialize();
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void effectiveFromHasChanged() {
        super.effectiveFromHasChanged();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IModelObject getParentModelObject() {
        if (hausratVertrag != null) {
            return hausratVertrag;
        }
        return null;
    }

    /**
     * @generated
     */
    public void setHausratVertragInternal(IHausratVertrag newParent) {
        if (getHausratVertrag() == newParent) {
            return;
        }
        IModelObject parent = getParentModelObject();
        if (newParent != null && parent != null) {
            throw new IllegalStateException(
                    "HausratZusatzdeckung kann nicht dem Parent Objekt der Klasse HausratVertrag hinzugefuegt werden, da das Objekt bereits einem anderen Parent Objekt zugeordnet ist.");
        }
        this.hausratVertrag = (HausratVertrag)newParent;
        effectiveFromHasChanged();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IVertrag getVertrag() {
        if (hausratVertrag != null) {
            return hausratVertrag;
        }
        return null;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public void notifyChangeListeners(PropertyChangeEvent event) {
        super.notifyChangeListeners(event);
        if (hausratVertrag != null) {
            ((INotificationSupport)hausratVertrag).notifyChangeListeners(event);
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void initPropertiesFromXml(Map<String, String> propMap, IRuntimeRepository productRepository) {
        super.initPropertiesFromXml(propMap, productRepository);
        doInitVersSumme(propMap);
    }

    /**
     * @generated
     */
    private void doInitVersSumme(Map<String, String> propMap) {
        if (propMap.containsKey(PROPERTY_VERSSUMME)) {
            this.versSumme = Money.valueOf(propMap.get(PROPERTY_VERSSUMME));
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected AbstractModelObject createChildFromXml(Element childEl) {
        AbstractModelObject newChild = super.createChildFromXml(childEl);
        if (newChild != null) {
            return newChild;
        }
        return null;
    }

    /**
     * Validierung von Objekten der Klasse HausratZusatzdeckung. Gibt <code>true</code> zurueck,
     * wenn dieses Objekt mit der Validierung fortfahren soll, <code>false</code> sonst.
     * 
     * @generated
     */
    @Override
    public boolean validateSelf(MessageList ml, IValidationContext context) {
        if (!super.validateSelf(ml, context)) {
            return STOP_VALIDATION;
        }
        return CONTINUE_VALIDATION;
    }

    /**
     * Validierung von abhaengigen Objekten fuer Instanzen der Klasse HausratZusatzdeckung.
     * 
     * @generated
     */
    @Override
    public void validateDependants(MessageList ml, IValidationContext context) {
        super.validateDependants(ml, context);
    }

}
