/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.util.List;
import java.util.Map;

import org.faktorips.runtime.FormulaExecutionException;
import org.faktorips.runtime.IProductComponent;
import org.faktorips.runtime.IProductComponentLink;
import org.faktorips.runtime.IllegalRepositoryModificationException;
import org.faktorips.runtime.internal.ValueToXmlHelper;
import org.faktorips.tutorial.hausrat.hausrat.IHausratVertrag;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckung;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstyp;
import org.faktorips.tutorial.hausrat.hausrat.IHausratZusatzdeckungstypGen;
import org.faktorips.tutorial.modell.internal.base.DeckungstypGen;
import org.faktorips.values.Decimal;
import org.faktorips.values.Money;
import org.w3c.dom.Element;

/**
 * Die Implementierung von IHausratZusatzdeckungstypGen.
 * 
 * @generated
 */
public class HausratZusatzdeckungstypGen extends DeckungstypGen implements IHausratZusatzdeckungstypGen {

    /**
     * Membervariable fuer die Produkteigenschaft VersSummenFaktor.
     * 
     * @generated
     */
    private Decimal versSummenFaktor;

    /**
     * Membervariable fuer die Produkteigenschaft MaxVersSumme.
     * 
     * @generated
     */
    private Money maxVersSumme;

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Decimal getVersSummenFaktor() {
        return versSummenFaktor;
    }

    /**
     * Setzt den Wert der Eigenschaft versSummenFaktor.
     * 
     * @generated
     */
    public void setVersSummenFaktor(Decimal newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setVersSummenFaktorInternal(newValue);
    }

    /**
     * Setzt den Wert des Attributs versSummenFaktor, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setVersSummenFaktorInternal(Decimal newValue) {
        this.versSummenFaktor = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money getMaxVersSumme() {
        return maxVersSumme;
    }

    /**
     * Setzt den Wert der Eigenschaft maxVersSumme.
     * 
     * @generated
     */
    public void setMaxVersSumme(Money newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setMaxVersSummeInternal(newValue);
    }

    /**
     * Setzt den Wert des Attributs maxVersSumme, ohne ein Change-Event auszulösen.
     * 
     * @generated
     */
    protected final void setMaxVersSummeInternal(Money newValue) {
        this.maxVersSumme = newValue;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public Money berechneJahresbasisbeitrag(IHausratZusatzdeckung deckung, IHausratVertrag vertrag)
            throws FormulaExecutionException {
        return (Money)getFormulaEvaluator().evaluate("berechneJahresbasisbeitrag", deckung, vertrag);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckungstyp getHausratZusatzdeckungstyp() {
        return (IHausratZusatzdeckungstyp)getProductComponent();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    protected void doInitPropertiesFromXml(Map<String, Element> configMap) {
        super.doInitPropertiesFromXml(configMap);
        doInitVersSummenFaktor(configMap);
        doInitMaxVersSumme(configMap);
    }

    /**
     * @generated
     */
    private void doInitVersSummenFaktor(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_VERSSUMMENFAKTOR);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.versSummenFaktor = Decimal.valueOf(value);
        }
    }

    /**
     * @generated
     */
    private void doInitMaxVersSumme(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_MAXVERSSUMME);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.maxVersSumme = Money.valueOf(value);
        }
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckung createHausratZusatzdeckung() {
        HausratZusatzdeckung policy = new HausratZusatzdeckung(getHausratZusatzdeckungstyp());
        policy.setProductCmptGeneration(this);
        policy.initialize();
        return policy;
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IHausratZusatzdeckung createPolicyComponent() {
        return createHausratZusatzdeckung();
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public IProductComponentLink<? extends IProductComponent> getLink(String linkName, IProductComponent target) {
        return super.getLink(linkName, target);
    }

    /**
     * {@inheritDoc}
     * 
     * @generated
     */
    @Override
    public List<IProductComponentLink<? extends IProductComponent>> getLinks() {
        List<IProductComponentLink<? extends IProductComponent>> list = super.getLinks();
        return list;
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstypGen.
     * 
     * @generated
     */
    public HausratZusatzdeckungstypGen(HausratZusatzdeckungstyp productCmpt) {
        super(productCmpt);
    }

}
