/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.NoSuchElementException;

import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.internal.Table;
import org.faktorips.runtime.internal.tableindex.TwoColumnRangeStructure;
import org.faktorips.runtime.internal.tableindex.UniqueResultStructure;

/**
 * Diese Klasse implementiert eine Read-Only In-Memory-Tabelle. Auf die Daten der Tabelle kann ueber
 * Finder-Methoden zugegriffen werden.
 * 
 * @generated
 */
public class Tarifzonentabelle extends Table<TarifzonentabelleRow> {

    /**
     * Membervariable die Keys auf Tabellenzeilen abbildet.
     * 
     * @generated
     */
    private TwoColumnRangeStructure<String, UniqueResultStructure<TarifzonentabelleRow>, TarifzonentabelleRow> key0SearchStructure;

    /**
     * Erzeugt einen leeren Tabelleninhalt.
     * 
     * @generated
     */
    public Tarifzonentabelle() {
        super();
    }

    /**
     * Erzeugt einen neuen Tabelleninhalt mit den uebergebenen Zeilen. Die Liste mit den Zeilen wird
     * kopiert. Spaetere Aenderungen an dem Inhalt der Liste, aendern also nicht die erzeugte
     * Tabelle. Dieser Konstruktor ist vor allem fuer die Verwendung in JUnit Tests vorgesehen, um
     * beliebige Tabelleninhalte erzeugen zu koennen.
     * 
     * @generated
     */
    public Tarifzonentabelle(List<TarifzonentabelleRow> content) {
        super();
        rows = new ArrayList<TarifzonentabelleRow>(content);
        init();
    }

    /**
     * Diese Methode wird waehrend der Initialisierung verwendet. Sie fuegt eine neue Tabellenzeile
     * hinzu.
     * 
     * @generated
     */
    @Override
    protected void addRow(List<String> values, IRuntimeRepository productRepository) {
        String columnValue = values.get(0);
        String plzVon = columnValue == null ? null : columnValue;
        columnValue = values.get(1);
        String plzBis = columnValue == null ? null : columnValue;
        columnValue = values.get(2);
        String tarifzone = columnValue == null ? null : columnValue;
        rows.add(new TarifzonentabelleRow(plzVon, plzBis, tarifzone));
    }

    /**
     * Initialisiert die Maps dieser Tabelle. Diese werden von den Finder-Methoden dieser Klasse
     * verwendet.
     * 
     * @generated
     */
    @Override
    protected final void initKeyMaps() {
        key0SearchStructure = TwoColumnRangeStructure
                .<String, UniqueResultStructure<TarifzonentabelleRow>, TarifzonentabelleRow> create();
        for (TarifzonentabelleRow row : rows) {
            key0SearchStructure.put(row.getPlzVon(), row.getPlzBis(), UniqueResultStructure.createWith(row));
        }
    }

    /**
     * Gibt die Instanz dieser Tabellenklasse zurueck.
     * 
     * @generated
     */
    public static final Tarifzonentabelle getInstance(IRuntimeRepository repository) {
        return repository.getTable(Tarifzonentabelle.class);
    }

    /**
     * Gibt die Instanz dieser Tabellenklasse zurueck.
     * 
     * @generated
     */
    public static final Tarifzonentabelle getInstance(IRuntimeRepository repository, String qualifiedTableName) {
        return (Tarifzonentabelle)repository.getTable(qualifiedTableName);
    }

    /**
     * Gibt alle Zeilen dieser Tabelle zurueck.
     * 
     * @generated
     */
    public List<TarifzonentabelleRow> getAllRows() {
        return Collections.unmodifiableList(rows);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurueck. Null wird zurueckgegeben falls kein Eintrag gefunden wird.
     * 
     * @generated
     */
    public TarifzonentabelleRow findRow(String plz) {
        return key0SearchStructure.get(plz).getUnique(null);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurück. Eine 'Null-Row' wird zurueckgegeben, falls kein Eintrag gefunden wird.
     * 
     * @generated
     */
    public TarifzonentabelleRow findRowNullRowReturnedForEmtpyResult(String plz) {
        return key0SearchStructure.get(plz).getUnique(TarifzonentabelleRow.NULL_ROW);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurück. Eine Exception wird geworfen, falls kein Eintrag gefunden wird.
     * 
     * @return Gibt die gesuchte Zeile zurück.
     * @throws IllegalArgumentException Wenn keine Zeile gefunden wurde.
     * 
     * @generated
     */
    public TarifzonentabelleRow findExistingRow(String plz) {
        try {
            return key0SearchStructure.get(plz).getUnique();
        } catch (NoSuchElementException e) {
            throw new IllegalArgumentException(
                    "Es wurde keine Zeile in Tabelle Tarifzonentabelle mit folgenden Suchparametern gefunden:  plz = "
                            + plz);
        }
    }

}
