/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */
package org.faktorips.tutorial.hausrat.internal.hausrat;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.internal.Table;
import org.faktorips.tutorial.hausrat.hausrat.enums.Versicherungsort;
import org.faktorips.values.Decimal;
import org.faktorips.runtime.internal.tableindex.KeyStructure;
import org.faktorips.runtime.internal.tableindex.UniqueResultStructure;
import java.util.NoSuchElementException;
import org.faktorips.values.ObjectUtil;

/**
 * Diese Klasse implementiert eine Read-Only In-Memory-Tabelle. Auf die Daten der Tabelle kann ueber
 * Finder-Methoden zugegriffen werden.
 * 
 * @generated
 */
public class ZuschlagVersicherungsort extends Table<ZuschlagVersicherungsortRow> {

    /**
     * Membervariable die Keys auf Tabellenzeilen abbildet.
     * 
     * @generated
     */
    private KeyStructure<Index0, UniqueResultStructure<ZuschlagVersicherungsortRow>, ZuschlagVersicherungsortRow> key0SearchStructure;

    /**
     * Erzeugt einen leeren Tabelleninhalt.
     * 
     * @generated
     */
    public ZuschlagVersicherungsort() {
        super();
    }

    /**
     * Erzeugt einen neuen Tabelleninhalt mit den uebergebenen Zeilen. Die Liste mit den Zeilen wird
     * kopiert. Spaetere Aenderungen an dem Inhalt der Liste, aendern also nicht die erzeugte
     * Tabelle. Dieser Konstruktor ist vor allem fuer die Verwendung in JUnit Tests vorgesehen, um
     * beliebige Tabelleninhalte erzeugen zu koennen.
     * 
     * @generated
     */
    public ZuschlagVersicherungsort(List<ZuschlagVersicherungsortRow> content) {
        super();
        rows = new ArrayList<ZuschlagVersicherungsortRow>(content);
        init();
    }

    /**
     * Diese Methode wird waehrend der Initialisierung verwendet. Sie fuegt eine neue Tabellenzeile
     * hinzu.
     * 
     * @generated
     */
    @Override
    protected void addRow(List<String> values, IRuntimeRepository productRepository) {
        String columnValue = values.get(0);
        Versicherungsort versicherungsort = columnValue == null ? null : Versicherungsort.getValueById(columnValue);
        columnValue = values.get(1);
        Decimal faktor = columnValue == null ? Decimal.NULL : Decimal.valueOf(columnValue);
        rows.add(new ZuschlagVersicherungsortRow(versicherungsort, faktor));
    }

    /**
     * Initialisiert die Maps dieser Tabelle. Diese werden von den Finder-Methoden dieser Klasse
     * verwendet.
     * 
     * @generated
     */
    @Override
    protected final void initKeyMaps() {
        key0SearchStructure = KeyStructure
                .<Index0, UniqueResultStructure<ZuschlagVersicherungsortRow>, ZuschlagVersicherungsortRow> create();
        for (ZuschlagVersicherungsortRow row : rows) {
            key0SearchStructure.put(new Index0(row.getVersicherungsort()), UniqueResultStructure.createWith(row));
        }
    }

    /**
     * Gibt die Instanz dieser Tabellenklasse zurueck.
     * 
     * @generated
     */
    public static final ZuschlagVersicherungsort getInstance(IRuntimeRepository repository) {
        return repository.getTable(ZuschlagVersicherungsort.class);
    }

    /**
     * Gibt die Instanz dieser Tabellenklasse zurueck.
     * 
     * @generated
     */
    public static final ZuschlagVersicherungsort getInstance(IRuntimeRepository repository, String qualifiedTableName) {
        return (ZuschlagVersicherungsort)repository.getTable(qualifiedTableName);
    }

    /**
     * Gibt alle Zeilen dieser Tabelle zurueck.
     * 
     * @generated
     */
    public List<ZuschlagVersicherungsortRow> getAllRows() {
        return Collections.unmodifiableList(rows);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurueck. Null wird zurueckgegeben falls kein Eintrag gefunden wird.
     * 
     * @generated
     */
    public ZuschlagVersicherungsortRow findRow(Versicherungsort versicherungsort) {
        return key0SearchStructure.get(new Index0(versicherungsort)).getUnique(null);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurück. Eine 'Null-Row' wird zurueckgegeben, falls kein Eintrag gefunden wird.
     * 
     * @generated
     */
    public ZuschlagVersicherungsortRow findRowNullRowReturnedForEmtpyResult(Versicherungsort versicherungsort) {
        return key0SearchStructure.get(new Index0(versicherungsort)).getUnique(ZuschlagVersicherungsortRow.NULL_ROW);
    }

    /**
     * Durchsucht den Inhalt dieser Tabelle nach einem Eintrag entsprechend der Suchkriterien und
     * gibt diesen zurück. Eine Exception wird geworfen, falls kein Eintrag gefunden wird.
     * 
     * @return Gibt die gesuchte Zeile zurück.
     * @throws IllegalArgumentException Wenn keine Zeile gefunden wurde.
     * 
     * @generated
     */
    public ZuschlagVersicherungsortRow findExistingRow(Versicherungsort versicherungsort) {
        try {
            return key0SearchStructure.get(new Index0(versicherungsort)).getUnique();
        } catch (NoSuchElementException e) {
            throw new IllegalArgumentException(
                    "Es wurde keine Zeile in Tabelle ZuschlagVersicherungsort mit folgenden Suchparametern gefunden:  versicherungsort = "
                            + versicherungsort);
        }
    }

    /**
     * Die Objekte dieser Klasse werden als Hash-Keys verwendent. Fuer jeden Zugriffsschluessel hat
     * diese Klasse eine eigene java.util.Map.
     * 
     * @generated
     */
    private static final class Index0 {

        /**
         * @generated
         */
        private final Versicherungsort versicherungsort;

        /**
         * Cached hashcode.
         * 
         * @generated
         */
        private final int hashCode;

        /**
         * Erzeugt eine neue Instanz mit den angegebenen Parameterwerten.
         * 
         * @generated
         */
        private Index0(Versicherungsort versicherungsort) {
            this.versicherungsort = versicherungsort;
            hashCode = calculateHashCode();
        }

        /**
         * @generated
         */
        private int calculateHashCode() {
            int result = 17;
            result = 37 * result + ((versicherungsort == null) ? 0 : versicherungsort.hashCode());
            return result;
        }

        /**
         * Ueberschreibt die Methode der Vaterklasse und vergleicht die Werte der Instanzvariablen
         * auf ihre Gleichheit.
         * 
         * @generated
         */
        @Override
        public boolean equals(Object o) {
            if (o instanceof Index0) {
                Index0 other = (Index0)o;
                return ObjectUtil.equals(versicherungsort, other.versicherungsort);
            }
            return false;
        }

        /**
         * Ueberschreibt die Methode der Vaterklasse und erzeugt einen Hash-Code basierend auf den
         * Werten der Attribute dieser Klasse.
         * 
         * @generated
         */
        @Override
        public int hashCode() {
            return hashCode;
        }

    }

}
