/*
 * BEGIN FAKTORIPS GENERATOR INFORMATION SECTION
 * 
 * builder set: org.faktorips.devtools.stdbuilder.ipsstdbuilderset, Version: 3.0.0
 * 
 * END FAKTORIPS GENERATOR INFORMATION SECTION
 */

package org.faktorips.tutorial.hausrat.internal.hausrat;

import org.faktorips.tutorial.hausrat.hausrat.enums.Versicherungsort;
import org.faktorips.values.Decimal;

/**
 * Diese Klasse repraesentiert eine (Read-Only) Zeile einer Tabelle.
 */
public class ZuschlagVersicherungsortRow {

    public final static ZuschlagVersicherungsortRow NULL_ROW = new ZuschlagVersicherungsortRow(null, Decimal.NULL);

    private Versicherungsort versicherungsort;

    private Decimal faktor;

    /**
     * Erzeugt eine neue Zeile.
     */
    public ZuschlagVersicherungsortRow(Versicherungsort versicherungsort, Decimal faktor) {

        this.versicherungsort = versicherungsort;
        this.faktor = faktor;
    }

    /**
     * Gibt den Werte der Spalte zurueck.
     */
    public Versicherungsort getVersicherungsort() {
        return versicherungsort;
    }

    /**
     * Gibt den Werte der Spalte zurueck.
     */
    public Decimal getFaktor() {
        return faktor;
    }

    @Override
    public String toString() {
        return "" + versicherungsort + "|" + faktor;
    }
}